#
#   IRC Script Program. For use with ircii-EPIC4 clients.
#   Copyright (C) 2000 SrfRoG (cag@codehack.com)
#
# ---------------------------------------------------------------------------
# All code by SrfRoG, unless specified. Visit http://lice.codehack.com
# ---------------------------------------------------------------------------

PACKAGE LiCe

ALIAS sc {
  IF ([$0]==[-f]) {
    NAMES ${ischannel($1)?[$1]:C}
    RETURN
  }
  @ :chan = ischannel($0) ? [$0] : C
  UNLESS (onchannel($N $chan)) {
    NAMES $chan
    RETURN
  }

  @ :max = fmt.sc_max() ? fmt.sc_max() : (word(0 $geom()) - 1) / 11
  @ scn.v = scn.o = scn.l = 0
  @ :scn.list = []

  ECHO $fmt.sc_top($chan)
  FE ($channel($chan)) nick {
    PUSH scn.list $_proc.scn_mode($nick)
    IF (numwords($scn.list) != max) {CONTINUE}
    ECHO $fmt.sc_mid($scn.list)
    @ :scn.list = []
  }
  IF (strlen($scn.list)) {ECHO $fmt.sc_mid($scn.list)}
  @ :scn.t = scn.v + scn.o + scn.l
  ECHO $fmt.sc_bot($chan $scn.o $scn.v $scn.l $scn.t)
  purge scn
}

ALIAS _proc.scn_mode (nick) {
  @ :nic = rest(2 $nick)
  @ :mod = pass(+@ $nick)
  IF (mod == [@]) {
    @ scn.o++
  } ELSIF (mod == [+]) {
    @ scn.v++
  } ELSE {
    IF (strlen($nick)) {@ scn.l++}
  }
  @ :ret = mod ## nic
  RETURN $ret
}
